{-# LANGUAGE MultiParamTypeClasses, FlexibleInstances #-}

module EnvT(EnvT, EnvMonad(rdEnv, inEnv), EnvType(initialEnv)) where
import Control.Monad
import AuxTypes

newtype EnvT env m a	= EnvT {fromEnvT :: env -> m a}

instance Monad m => Monad (EnvT env m) where
       return a	= EnvT (\e -> return a)
       EnvT m >>= k	= EnvT (\e -> do a <- m e
                                         fromEnvT (k a) e)

class Monad m => EnvMonad env m where
       rdEnv		:: m env
       inEnv		:: env -> m a -> m a

instance Monad m => EnvMonad env (EnvT env m) where
       rdEnv		= EnvT (\r -> return r)
       inEnv env m	= EnvT (\env' -> fromEnvT m env)

instance MonadT (EnvT env) where
       lift c		= EnvT (\env -> c)

class EnvType e where
       initialEnv      :: e

instance (EnvType e, Monad m, RunMonad m) => RunMonad (EnvT e m) where
       run (EnvT a)	= run (a initialEnv)
