module ErrorT (ErrorT, ErrMonad(err)) where

import Control.Monad
import AuxTypes

newtype ErrorT m a	= MkErrT {fromErrT :: m (Error a) }

instance Monad m => Monad (ErrorT m) where
       return a		= MkErrT (return (Ok a))
       MkErrT m >>= k		= MkErrT (m >>= r)
                                 where r (Error s)	= return (Error s)
                                       r (Ok x)	= fromErrT (k x)

instance MonadT ErrorT where
       lift 		= MkErrT . liftM Ok

class Monad m => ErrMonad m where
       err		:: String -> m a

instance Monad m => ErrMonad (ErrorT m) where
       err s		= MkErrT (return (Error s))

instance (Monad m, RunMonad m) => RunMonad (ErrorT m) where
       run (MkErrT a)		= case (run a) of
                                   Ok a -> a
                                   Error a -> Error a
