module Main where

import Language
import Parser
import TypeChecker
import AuxTypes
import Interpreter
import Matrix

import CircInterpreter
import QFqc

main =
   do s <- getContents
      let e = parse (lexer s)
--    print e
      case run (typecheck e) of
         Ok ce -> do
           putStrLn $ "Type: " ++ show (typ ce)
           putStrLn $ "Bits: " ++ show (exprbits ce)
           let c = circCon ce
           let vec = evalNoInp c
           let den = fqc2Den c
           let denByLampis = ev ce (d 0)
           --let diff = den |-| denByLampis
           --let m = fqc2Mat c
           print(c)
           print (vec)
           putStr "\nDENSITY MATRIX\n"
           print den
           --print (density vec)
           if (zeroDiff den denByLampis) 
             then putStrLn "The two interpreters gave the same result :)" 
             else putStrLn "The two interpreters gave different result :("
         Error msg -> 
           putStrLn ("Type error: " ++ msg)
