module Main where

import Language
import Parser
import TypeChecker
import AuxTypes
import Interpreter
import Matrix

import CircInterpreter
import QFqc

main = do
   s <- getContents
   case (run . typecheck . parse . lexer) s of
       Ok ce     -> do putStrLn $ "Type: " ++ show (typ ce)
                       putStrLn $ "Bits: " ++ show (exprbits ce)
                       let c = circCon ce
                           -- m = fqc2Mat c
                           vec = evalNoInp c
                           den = density vec
                       print c
                       print vec
                       print den
       Error msg -> putStrLn $ "Type error: " ++ msg
