module Main where

import Language
import Parser
import TypeChecker
import AuxTypes
import Interpreter
import Matrix

main =
   do s <- getContents
      let e = parse (lexer s)
--    print e
      case run (typecheck e) of
        Ok ce     -> do let t = typ ce
                        let n = exprbits ce
                        putStrLn $ "Type: " ++ show t
                        putStrLn $ "Bits: " ++ show n
                        let s0 = d 0
                        let sf = ev ce s0
                        putStrLn $ "State:"
                        print sf
                        putStrLn $ "Observed: "
                        print $ ptr (qbits t) sf
        Error msg -> do putStrLn $ "Type error: " ++ msg
